<?php
namespace Accounts\Permissions\Controller;

use Accounts\Permissions\Controller\AppController;
use Cake\Core\Plugin;
use Cake\Event\Event;
use Cake\Utility\Text;

/**
 * Permissions Controller
 *
 * @property \Accounts\Permissions\Model\Table\PermissionsTable $Permissions
 *
 * @method \Accounts\Permissions\Model\Entity\Permission[]|\Cake\Datasource\ResultSetInterface paginate($object = null, array $settings = [])
 */
class PermissionsController extends AppController
{
    public function initialize()
    {
        parent::initialize(); // TODO: Change the autogenerated stub
        $this->loadComponent('Accounts/Permissions.Actions');
        $this->loadModel('Accounts/Admin.Roles');
    }

    public function beforeRender(Event $event)
    {
        parent::beforeRender($event);
        $this->viewBuilder()->setHelpers(['Materialize.Form']);
    }
    /**
     * Index method
     *
     * @return \Cake\Http\Response|void
     */
    public function index()
    {
        $this->paginate = [
            'contain' => ['Roles']
        ];
        $permissions = $this->paginate($this->Permissions);

        $this->set(compact('permissions'));
    }

    public function selectRole()
    {
        $roles = $this->paginate($this->Roles);

        $this->set(compact('roles'));
    }

    /**
     * Add method
     *
     * @return \Cake\Http\Response|null Redirects on successful add, renders view otherwise.
     */
    public function add($role_id = null)
    {
        if (!$role_id) {
            $this->Flash->error(__d('Accounts/permissions', 'You must select a role'));
            return $this->redirect(['action' => 'select-role']);
        }

        $permission = $this->Permissions->newEntity();
        if ($this->request->is('post')) {
            $permission = $this->Permissions->patchEntity($permission, $this->request->getData());
            $permission->role_id = $role_id;
            if ($this->request->getData('plugin')) {
                $permission->plugin = str_replace('-', '/', $this->request->getData('plugin'));
            }
            $permission->controller = str_replace('-', '/', $this->request->getData('controller'));
            if ($this->Permissions->save($permission)) {
                $this->Flash->success(__d('Accounts/permissions', 'The permission has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__d('Accounts/permissions', 'The permission could not be saved. Please, try again.'));
        }
        $roles = $this->Permissions->Roles->find('list', ['limit' => 200]);
        $controllers = $this->Actions->listSlugedControllers();

        $this->set('plugins', $this->Actions->listPlugins());
        $this->set('controllers', $controllers);
        $this->set(compact('permission', 'roles'));
    }

    public function listCtls()
    {
        $plugin = $this->request->getQuery('plugin');
        if (!$plugin) {
            $controllers = $this->Actions->listSlugedControllers();
            $this->set(compact('controllers'));
            $this->set('_serialize', ['controllers']);
            return;
        }

        $parsed_plugin = Text::slug($plugin, '/');
        $controllers = $this->Actions->listSlugedControllers($parsed_plugin);

        $this->set(compact('controllers'));
        $this->set('_serialize', ['controllers']);
    }

    public function listActions()
    {
        $plugin = $this->request->getQuery('plugin');
        $controller = $this->request->getQuery('controller');

        if (!$plugin) {
            $controller_sluged = Text::slug($controller, '/');
            $raw_actions = $this->Actions->listControllerActions(null, $controller_sluged);

            foreach ($raw_actions as $key => $value) {
                $actions[$value] = $value;
            }

            $this->set(compact('actions'));
            $this->set('_serialize', ['actions']);
            return;
        }

        $plugin_sluged = Text::slug($plugin, '/');
        $controller_sluged = Text::slug($controller, '/');
        $raw_actions = $this->Actions->listControllerActions($plugin_sluged, $controller_sluged);

        foreach ($raw_actions as $key => $value) {
            $actions[$value] = $value;
        }

        $this->set(compact('actions'));
        $this->set('_serialize', ['actions']);

    }

    /**
     * Delete method
     *
     * @param string|null $id Permission id.
     * @return \Cake\Http\Response|null Redirects to index.
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function delete($id = null)
    {
        $this->request->allowMethod(['post', 'delete']);
        $permission = $this->Permissions->get($id);
        if ($this->Permissions->delete($permission)) {
            $this->Flash->success(__d('Accounts/permissions', 'The permission has been deleted.'));
        } else {
            $this->Flash->error(__d('Accounts/permissions', 'The permission could not be deleted. Please, try again.'));
        }

        return $this->redirect(['action' => 'index']);
    }
}
